import React, {Component} from 'react';
import ToolTip from '@beisen-platform/ethos/lib/ToolTip';
import { clearToolTipDom } from '@beisen-platform/common-func'

export default class Radioitem extends Component {
	constructor(props) {
	    super(props);

	    this.handelClick = this.handelClick.bind(this);
	}

	handelClick(event) {
		clearToolTipDom();
		this.props.itemClick && this.props.itemClick(event, this.props.item);
	}

	render() {
		const { item } = this.props;
		return (
			<li className={'recruit-dropdown-item'} onClick={this.handelClick}>
				<ToolTip title={item.text[0]}>
					<span className='recruit-dropdown-text d__name'>{item.text[0]}</span>
				</ToolTip>
				<ToolTip title={item.text[1]}>
					<span className='recruit-dropdown-text d__email'>{item.text[1]}</span>
				</ToolTip>
				<ToolTip title={item.text[2]}>
					<span className='recruit-dropdown-text d__apart'>{item.text[2]}</span>
				</ToolTip>
			</li>
		)
	}
}